#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->treeWidget->setColumnCount(3);
    QStringList list;
    list << "name" << "size" << "time";
    ui->treeWidget->setHeaderLabels (list);
}

MainWindow::~MainWindow()
{
    delete ui;
}

#include <QDir>


#include <QDateTime>

void MainWindow::showFile (QTreeWidgetItem * branch,
                           QFileInfo info,
                           int level)
{
    QTreeWidgetItem * u = new QTreeWidgetItem;
    u->setText (0, info.fileName());
    u->setToolTip (0, info.filePath());
    if (info.isFile())
    {
       u->setText(1, QString::number(info.size()));
       QString fmt = "yyyy-MM-dd hh:mm:ss";
       u->setText(2, info.lastModified().toString(fmt));
    }

    if (info.isDir())
       u->setTextColor (0, QColor (255, 128, 64));
    else
       u->setTextColor (0, QColor ("cornflowerblue"));

    if (branch == NULL)
       ui->treeWidget->addTopLevelItem (u);
    else
       branch->addChild (u);

    if (info.isFile())
    {
        QIcon * icon = new QIcon (info.filePath());
        u->setIcon (0, *icon);
    }

    if (info.isDir() && level > 1)
       showDir (u, info.filePath(), level);
}

void MainWindow::showDir (QTreeWidgetItem * u,
                          QString path,
                          int level)
{
    QDir d (path);
    QFileInfoList a = d.entryInfoList
      (QDir::Dirs | QDir::Files | QDir::NoDotAndDotDot);
    for (int i = 0; i < a.count(); i++)
      showFile (u, a[i], level-1);
}

void MainWindow::on_pushButton_clicked()
{
    showFile (NULL, QFileInfo ("/usr/share/icons"), 2);
}

void MainWindow::on_treeWidget_itemClicked
    (QTreeWidgetItem *item, int column)
{
    // item->setText (0, "click");
}

void MainWindow::on_treeWidget_itemExpanded (QTreeWidgetItem *item)
{
    item->setTextColor(0, QColor ("red"));

    int n = item->childCount();
    for (int i = 0; i < n; i++)
    {
        QTreeWidgetItem * p = item->child (i);

        QColor c = QColor::fromHsv (359*i/n, 255, 255);
        p->setTextColor(0, c);

        if (p->childCount() == 0)
        {
            QString s = p->toolTip (0);
            QFileInfo f (s);
            if (f.isDir())
               showDir (p, s, 2);
        }
    }


}
